#include "smgbalib.h"

// this is generated with pcx2gba.exe from a indexed colour pcx image
#include "bitmaps\wallpaper.h"
#include "bitmaps\ball.h"

int main() {

	// get ready for some displayin'
	Initialize();
	
	// we will use the palette in the wallpaper image! If you load wallpaper.pcx in an 
	// editing program such as GIMP, you will notice how I left colours 0 as black and 1 as white
	// This is so that transparent places seem "empty" (they use colour 0), and text will be white
	// (text output always uses colour 1 of the current palette)
	
	// this palette is conveniently created by pcx2gba.exe, along with the actual image data
	SetPalette( (u16*)wallpaperPalette );
	
	u16 w = (240-ball_WIDTH)/2;
	u16 h = 160-ball_HEIGHT;
	
	// current ball position
	int ballx = 20, bally = 20;

	// current ball direction
	u16 direction = 0;
	
	// main loop - should never exit it
	while(1) {

		// draw wallpaper!
		DrawFullScreenOpaque( (u16*)wallpaperData );

		// Since we can use only one palette, I suggest creating bitmaps based on the same palette
		// perhaps by copying a main pcx file, and then editing it, scaling it, but maintaining
		// its palette
		DrawBitmapTransparent( ballx, bally, ball_HEIGHT, ball_WIDTH, (u16*)ballData );
		
		/*
		DrawBitmapSectorTransparent( ballx, bally,
									 ball_HEIGHT, ball_WIDTH,
									 0, 0,
									 12, 12,
									 (u16*)ballData);
									 */
		
		WriteStringWide( 20, 152, "smgbalib bitmap demo!" );

		Flip();

		// Done drawing... now calculate new position and direction
		// for the ball!
		//
		// direction values:
		//
		//       1       0
		//        \     /
		//        /     \
		//       2       3
		//

		// move ball appropriately
		if(direction == 0 ) {ballx+=2;bally-=2;}
		if(direction == 1 ) {ballx-=2;bally-=2;}
		if(direction == 2 ) {ballx-=2;bally+=2;}
		if(direction == 3 ) {ballx+=2;bally+=2;}
		
		// check for a bounce (which would require changing direction)
		if( direction == 0 ) {
			if( ballx >= w && bally <= 0 ) {
				direction = 2;
			} else if ( ballx >= w ) {
				direction = 1;
			} else if ( bally <= 0 ) {
				direction = 3;
			}
		}

		if( direction == 1 ) {
			if( ballx <= 0 && bally <= 0 ) {
				direction = 3;
			} else if ( ballx <= 0 ) {
				direction = 0;
			} else if ( bally <= 0 ) {
				direction = 2;
			}
		}

		if( direction == 2 ) {
			if( ballx <= 0 && bally >= h ) {
				direction = 0;
			} else if ( ballx <= 0 ) {
				direction = 3;
			} else if ( bally >= h ) {
				direction = 1;
			}
		}

		if( direction == 3 ) {
			if( ballx >= w && bally >= h ) {
				direction = 1;
			} else if ( ballx >= w ) {
				direction = 2;
			} else if ( bally >= h ) {
				direction = 0;
			}
		}
		
	}
	
	return 0;
}


